# Git

## Workflow rules
1. Coding on Gwendolyn is performed in [feature branch workflow](https://www.atlassian.com/git/tutorials/comparing-workflows/feature-branch-workflow). This means all code should be added in a separate feature branch before it's added to the `master` branch.
1. Feature branches must be created from current `master` branch when
1. Never push to the `master` branch. All code from feature branches should be added with pull requests. [NikolajDanger](https://github.com/NikolajDanger) is the only developer who can accept pull requests to `master`.
1. ***All code*** pushed to `master` must:
    + Work
    + Be reachable when the bot is running
    + Follow the code style guidelines laid out later in this doc.
1. Code pushed to feature branches require none of those.

## Commit messages
Commit subject lines should not be longer than 72 characters. Each line in the body must not be longer than 80 characters.

### Emoji
Commit messages must start with an emoji relating to the nature of the commit, because emojis are fun. Emojis are put in commit messages with github shortcodes (e.g. :heart: is `:heart:`). [Emojipedia](https://emojipedia.org/) has the github shortcodes for all emoji.

There are no rules for which emoji to use where, but here are some inspiration:

:bug: (`:bug:`) - Fixing a bug

# Terminology

# Code

## Code Style

## Cogs

## Discord API

## Logging